#include <stdio.h>
#include <dlfcn.h>
#include <errno.h>
#include <sys/mman.h>
#include <string.h>

#define msg stderr


static void cacheflush(void *start, size_t size)
{
   /* For details, please see the Linux sources, files
    * arch/arm/kernel/traps.c, arch/arm/kernel/entry-common.S and
    * asm-arm/unistd.h
    *
    * This syscall is supported by all 2.4 and 2.6 Linux kernels.  2.2 linux
    * kernels got first support with version 2.2.18.
    */

   asm("mov r0, %0\n"
       "mov r1, %1\n"
       "mov r2, #0\n"
       /* EABI or Thumb syscall: syscall number passed in 'r7' (syscall base
	* number is 0x0).  Note that Thumb and EABI are generally not the
	* same.  It just happens that the simple cacheflush syscall doesn't
	* expose any of differences in calling conventions.
        */
       "mov r7, #0xf0000\n"
       "add r7, #0x02\n"
       "swi #0\n" ::
       "g"(start), "g"((long)start+size) :
       "r0", "r1", "r2", "r7");
}

void injector(const char *path) {
	unsigned *handle=NULL;
	if ((handle = dlopen(NULL,RTLD_LAZY | RTLD_GLOBAL)) == NULL) {
		fputs("Cannot open self!\n", msg);
		fputs(dlerror(), msg);
		return;
   }

	unsigned *KeyCommon_SendKeyPressInput = dlsym(handle,"_ZN9KeyCommon17SendKeyPressInputEii");
	if (KeyCommon_SendKeyPressInput == NULL) {
		fputs("Cannot find _ZN9KeyCommon17SendKeyPressInputEii functions!\n", msg);
		fputs(dlerror(), msg);
		fputs("\n", msg);
		return;
   }

	dlclose(handle);

	char filename[64];
	strcpy(filename, path);
	strcat(filename, "scaling.so");
	if ((handle = dlopen(filename, RTLD_NOW | RTLD_LOCAL | RTLD_NODELETE)) == NULL) {
		fputs("Cannot open scaling.so!\n", msg);
		fputs (dlerror(), msg);
		fputs("\n", msg);
		return;
   }
	unsigned *mod_injection = dlsym(handle,"resizing_injection");
	dlclose(handle);

 	int page = ((unsigned) KeyCommon_SendKeyPressInput) & ~0x0FFF;
	mprotect((void *) page, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);

	if (KeyCommon_SendKeyPressInput[4] == 0xE51FF004)	// remapped already (by other application) ?
	{
	   //debug("- old injection detected");
	   // modify ex_injection returning command (self-injection)
	   int page2 = ((unsigned) mod_injection) & ~0x0FFF;
	   mprotect((void *) page2, 8192, PROT_READ | PROT_WRITE | PROT_EXEC);
	   mod_injection[9]  = KeyCommon_SendKeyPressInput[4];
	   mod_injection[10] = KeyCommon_SendKeyPressInput[5];
	   mprotect((void *) page2, 8192, PROT_READ | PROT_EXEC);
	   cacheflush(mod_injection+9, 8);
	}
	// else first injection...
	// set "classic" injection function
	KeyCommon_SendKeyPressInput[4] = 0xE51FF004;
	KeyCommon_SendKeyPressInput[5] = (unsigned)mod_injection;
	mprotect((void *) page, 8192, PROT_READ | PROT_EXEC);
	cacheflush(KeyCommon_SendKeyPressInput+4, 8);	
	
}

int Game_Main(const char  *path, const char *udn __attribute__ ((unused)))
{
	injector(path);
	return 1;
}
