// Tested only on LExxB650T2W with T-CHL7DEUC 2005.0 firmware;
// use at your own risk !!!

#include <stdio.h>
#include <stdlib.h>
#include <sys/syscall.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#include "sd_video.h"

#define FHD_W 1920
#define FHD_H 1080
#define KEY_NOTHING 0x1c

extern int _ZN9KeyCommon17SendKeyPressInputEii(int, int, int);
extern unsigned int g_AppTV;

static int modes = 0;
static int activ = 0;

static int g_step=24;


// Resizing related functions
static int roundf (float argum) {
	if ((argum-(int)(argum)) < 0.5) return((int)argum);
	else return((int)argum+1);
}


static int _sdvideo_get (int sd_i, SdVideo_Settings_t *p) {
   memset(p, 0, sizeof(SdVideo_Settings_t));
   int res=_Z11SdVideo_Get11SdVideoID_kP18SdVideo_Settings_t(sd_i, p);
   if (!res) return(0);
   printf("SD(): ERROR: SdVideo_Get(%i) return=%d\n", sd_i, res);
   return(-1);
}


static int _sd_capture_change(int sd_i, int stepx) {
   int res;
   int kstep,limx,limy,limk;
   float ar, k, ky;
   SdVideo_Settings_t s;
   SdVideo_Settings_t *p=&s;
   int x,y,w,h,x_crop,y_crop,w_res,h_res;
   int min_w=240; int min_h=160;
   
   if (_sdvideo_get(sd_i, p)) {
      printf(" No valid input on screen "); return(-1); }
   if (p->capt_hActive < min_h || p->capt_vActive < min_w) return(-1);
   
   x=p->sGe_x; y=p->sGe_y; w=p->sGe_width; h=p->sGe_height;
   x_crop=p->capt_hStart; y_crop=p->capt_vStart; w_res=p->capt_hResolution; h_res=p->capt_vResolution;

	limx=0; limy=0;
	ar=(float)(p->capt_hActive)/(float)(p->capt_vActive);	
	if (p->capt_vActive == 576) {limx=27; limy=19; ar=4./3.;}	

	if ((unsigned)(h_res+2*y_crop-p->capt_vActive) > limy)
		y_crop=roundf((p->capt_vActive-h_res)/2);

	if (((w+2*stepx) <= FHD_W) && (x_crop <= limx)){
		k=(float)(w+2*stepx)/(float)(w);
		w=w+2*stepx;
		x=roundf((FHD_W-w)/2);}
	else
		if (w < FHD_W) {k=FHD_W/w; w=FHD_W; x=0;}
		else {
			kstep=stepx*p->capt_hActive/FHD_W;
			if ((w_res-2*kstep) <= (p->capt_hActive-2*limx)) {
				k=(float)(w_res)/(float)(w_res-2*kstep);
				w_res=w_res-2*kstep;
				x_crop=roundf((p->capt_hActive-w_res)/2);}
			else  {
				k=(float)(p->capt_hActive-2*limx)/(float)(w_res); 
				w_res=p->capt_hActive-2*limx;
				x_crop=limx;}
			}

	if ((roundf(h*k) <= FHD_H) && (y_crop <= limy)) {
		h=roundf(h*k);
		y=round(FHD_H-h)/2;}
	else {
		h=FHD_H; y=0;
		if (roundf(h_res/k) <= (p->capt_vActive-2*limy)) {
			h_res=roundf(h_res/k);
			y_crop=roundf((p->capt_vActive-h_res)/2);}
		else {
			ky=(float)(h_res)/(float)(p->capt_vActive-2*limy);
			h_res=p->capt_vActive-2*limy;
			y_crop=limy;
			if ((roundf(w*ky) <= FHD_W) && (x_crop <= limx)) {
				w=roundf(h*ar);
				x=roundf(FHD_W-w)/2;}
			else {
				w_res=roundf(w_res*ky);		
				x_crop=roundf((p->capt_hActive-w_res)/2);
			}
				
		}
	}

	if ( (w < (FHD_W/2)) || (h < (FHD_H/2)) || (h_res < (p->capt_vActive/3)) || (w_res < (p->capt_hActive/3)) )
		{ printf("\nOut of range\n"); return(-1);}

	p->sGe_x=x; p->sGe_y=y; p->sGe_width=w; p->sGe_height=h;
	p->capt_hStart=x_crop; p->capt_vStart=y_crop; p->capt_hResolution=w_res; p->capt_vResolution=h_res;      

   	if (res=_Z11SdVideo_Set11SdVideoID_kP18SdVideo_Settings_t(0, p)) {
      		printf("SD(C): ERROR: SdVideo_Set() return=%d\n !!!", res); return(-1); }

   //_sdl_txt(mtxt, 700, 0);
 
   return(0);
}

static int _sd_capture_move(int sd_i, int stepx) {
   int res;
   int kstep,limy;
   float ar;
   SdVideo_Settings_t s;
   SdVideo_Settings_t *p=&s;
   int x,y,w,h,x_crop,y_crop,w_res,h_res;
   int min_w=240; int min_h=160;
   
   if (_sdvideo_get(sd_i, p)) {
      printf(" No valid input on screen "); return(-1); }
   
	x=p->sGe_x; y=p->sGe_y; w=p->sGe_width; h=p->sGe_height;
	x_crop=p->capt_hStart; y_crop=p->capt_vStart; w_res=p->capt_hResolution; h_res=p->capt_vResolution;

	kstep=stepx/3;
	limy=0;
	if (p->capt_vActive == 576) {limy=19;}	

	if ((y_crop >= (limy-kstep)) && ((y_crop+h_res+kstep+limy) <= p->capt_vActive))
		y_crop=y_crop+kstep;

   	p->sGe_x=x; p->sGe_y=y; p->sGe_width=w; p->sGe_height=h;
   	p->capt_hStart=x_crop; p->capt_vStart=y_crop; p->capt_hResolution=w_res; p->capt_vResolution=h_res;

   	if (res=_Z11SdVideo_Set11SdVideoID_kP18SdVideo_Settings_t(0, p)) {
      		printf("SD(C): ERROR: SdVideo_Set() return=%d\n !!!", res); return(-1); }

//	_sdl_txt(mtxt, 700, 0);
 
   	return(0);
}

static int _sd_capture_orig(int sd_i) {
   int res;
   int limx,limy;
   float ar;
   SdVideo_Settings_t s;
   SdVideo_Settings_t *p=&s;
   int x,y,w,h,x_crop,y_crop,w_res,h_res;
   int min_w=240; int min_h=160;
   
   	if (_sdvideo_get(sd_i, p)) {
      		printf(" No valid input on screen "); return(-1); }
   
  	x=p->sGe_x; y=p->sGe_y; w=p->sGe_width; h=p->sGe_height;
   	x_crop=p->capt_hStart; y_crop=p->capt_vStart; w_res=p->capt_hResolution; h_res=p->capt_vResolution;

	limx=0; limy=0;
	if (p->capt_vActive == 576) {limx=27; limy=19; ar=4.0/3.0;}
	else ar=(float)p->capt_hActive/(float)p->capt_vActive;

	y_crop = limy;
	x_crop = limx;
	h_res=p->capt_vActive-2*y_crop;
	w_res=p->capt_hActive-2*x_crop;	
	if (ar > ((float)FHD_W/(float)FHD_H)) {w=FHD_W; h=FHD_W/ar;}
	else {h=FHD_H; w=h*ar;}
	x=(FHD_W-w)/2; y=(FHD_H-h)/2;

   	p->sGe_x=x; p->sGe_y=y; p->sGe_width=w; p->sGe_height=h;
   	p->capt_hStart=x_crop; p->capt_vStart=y_crop; p->capt_hResolution=w_res; p->capt_vResolution=h_res;

   	if (res=_Z11SdVideo_Set11SdVideoID_kP18SdVideo_Settings_t(0, p)) {
      		printf("SD(C): ERROR: SdVideo_Set() return=%d\n !!!", res); return(-1); }

//   	_sdl_txt(mtxt, 700, 0);
 
   	return(0);
}


static int _video_resize_process(int key) __attribute__ ((noinline));
static int _video_resize_process(int key) {
	int sd_i=0;
	
	if (key == 0x14) { // "GREEN"
		if (activ == 0 ) modes++; else modes=0;
		if (modes < 2) activ=0; else activ=1;
		printf("\n Key GREEN pressed, active is %d! \n",activ);
		return(key);
	}
if (activ == 1) {
	
   	// change capture
   	if (key == 0x65) { // KEY_CUR_LEFT
      		_sd_capture_change(sd_i,-g_step);
      		return(KEY_NOTHING);
   	}
   	if (key == 0x62) { // KEY_CUR_RIGHT
      		_sd_capture_change(sd_i,+g_step);
      		return(KEY_NOTHING);
   	}
 

   	if (key == 0x60) { // KEY_CUR_UP
      		_sd_capture_move(sd_i,+g_step);
      		return(KEY_NOTHING);
  	}
   	if (key == 0x61) { // KEY_CUR_DOWN
      		_sd_capture_move(sd_i,-g_step);
      		return(KEY_NOTHING);
  	}

   	if (key == 0x68) { // KEY_ENTER
      		_sd_capture_orig(sd_i);
      		return(KEY_NOTHING);
  	}

}   
	return(key);		
}

void resizing_injection(int a, int key, int arg_r2) __attribute__ ((noinline));
void resizing_injection(int a, int key, int arg_r2) {
	// gcc should put "STMFD SP!, {R4,LR}" on top, if everything goes as planned
	asm volatile(
		"STMFD   SP!, {R0,R2,R3,R12}\n");
	
	_video_resize_process(key);
	
	asm volatile(
		"MOV     R1, R0\n" // remapped keycode
		"MOV     R6, R0\n" // remapped keycode
		"LDMFD   SP!, {R0,R2,R3,R12}\n"
		"LDMFD   SP!, {R4,LR}\n"
		"MOV     R7, R2\n"  //This is original command that we overwrite
		"LDR     R3, [R8]\n"  //This is original command that we overwrite
		"LDR     PC, =(_ZN9KeyCommon17SendKeyPressInputEii + 0x18 )\n"	//return after injection
	);
}
